<script>
    export let xScale;
    export let subplot;
    export let clip_path_url;
    $: leftMargin = xScale.range()[0];
    $: rightMargin = xScale.range()[1];

    function getNested(obj, ...args) {
        return args.reduce((obj, level) => obj && obj[level], obj);
    }

    let annot_lines = [];
    let annot_text_items = [];
    let annot_background_colors = [];

    $: {
        annot_background_colors = getNested(
            subplot,
            "annot_options",
            "annot_background_colors",
        );
        annot_lines = getNested(
            subplot,
            "annot_options",
            "annot_horizontal_grid_lines",
        );
        annot_text_items = getNested(
            subplot,
            "annot_options",
            "annot_text_items",
        );
        if (!annot_lines) {
            annot_lines = [];
        }
        if (!annot_text_items) {
            annot_text_items = [];
        }
        if (!annot_background_colors) {
            annot_background_colors = [];
        }
    }

    const compute_annot_x = function (
        annot_text_item,
        rightMargin,
        leftMargin,
    ) {
        if (annot_text_item.align == "right") {
            if (annot_text_item.position == "inside") {
                return rightMargin - 7;
            } else {
                return leftMargin - 7;
            }
        } else {
            if (annot_text_item.position == "inside") {
                return leftMargin + 7;
            } else {
                return rightMargin + 7;
            }
        }
    };

    let annot_font_height = 11;
</script>

<g class="foreground_yscale_annotation">
    {#each annot_lines as annot_line}
        {#if annot_line.y >= subplot.computed.yScale.domain()[0] && annot_line.y <= subplot.computed.yScale.domain()[1]}
            <line
                x1={leftMargin}
                x2={rightMargin}
                y1={subplot.computed.yScale(annot_line.y)}
                y2={subplot.computed.yScale(annot_line.y)}
                class="stroke-black dark:stroke-white"
                stroke="black"
                stroke-width="0.5px"
                stroke-opacity="50%" />
        {/if}
    {/each}
    {#each annot_text_items as annot_text_item}
        {#if annot_text_item.y >= subplot.computed.yScale.domain()[0] && annot_text_item.y <= subplot.computed.yScale.domain()[1]}
            <text
                x={compute_annot_x(annot_text_item, rightMargin, leftMargin)}
                y={subplot.computed.yScale(annot_text_item.y)}
                font-family="-apple-system, 'Helvetica Neue', sans-serif"
                font-size={annot_font_height}
                fill="black"
                class="fill-black dark:fill-white"
                text-anchor={annot_text_item.align == "right" ? "end" : "begin"}
                dominant-baseline="middle">
                {annot_text_item.text}
            </text>
        {/if}
    {/each}
</g>
